// Listaarq.h
#include <stdlib.h>
#include <stdio.h>
#include <io.h>
#include <iostream.h>

// o comprimento ser armazenado nos 4 primeiros bytes

struct Lista{
        FILE *arq;
};

void init   (Lista&);
void inserir(Lista&, tipo_do_elemento, int);
void alterar(Lista&, tipo_do_elemento, int);
int  vazia  (Lista);
int  compr  (Lista&);
tipo_do_elemento eliminar (Lista&, int);
tipo_do_elemento consultar(Lista , int);
        

void init(Lista& l)
{
	 
        int comp=0;
		
		l.arq = fopen(nome_arquivo, "wb");

        if   (l.arq == NULL)
		{ 
			cout<< " ERRO na abertura do arquivo";
			exit(1);     
		}
        fwrite(&(comp), sizeof(comp),1,l.arq);
        fclose(l.arq);
}

void inserir(Lista& l, tipo_do_elemento y, int i)
{
        tipo_do_elemento x;
		int comp;

        l.arq = fopen(nome_arquivo, "rb+");	

    // teste para verificar se ocorreu algum erro com a abertura

        if   (l.arq == NULL)
		{ 
			cout<< " ERRO na abertura do arquivo";
			exit(1);     
		}
         
		fseek(l.arq, 0,0);
		fread(&comp, sizeof(comp),1,l.arq);
		
		if((i <= 0) || (i> comp+1))
		{
			cerr<< "posicao invalida";
			exit(1);
		}
		else 
		{       
			if(i<= comp)

				for(int k=comp; k>=i;k--)
				{
					fseek (l.arq,(k-1)*sizeof(tipo_do_elemento)+4,0);
					fread (&x,sizeof(tipo_do_elemento),1,l.arq);
					fseek (l.arq,(k)*sizeof(tipo_do_elemento)+4,0);
					fwrite(&x,sizeof(tipo_do_elemento),1,l.arq);
				}
				
				fseek(l.arq,(i-1)*sizeof(tipo_do_elemento)+4,0);
				fwrite(&y,sizeof(tipo_do_elemento),1,l.arq);
				
				comp++;
				fseek(l.arq,0,0);
				fwrite(&comp,sizeof(comp),1,l.arq);
		}
		fclose(l.arq);
}

tipo_do_elemento eliminar(Lista& l, int i)
{
        tipo_do_elemento x;
		int comp;

       l.arq = fopen(nome_arquivo, "rb+");	

    // teste para verificar se ocorreu algum erro com a abertura

        if   (l.arq == NULL)
		{ 
			cout<< " ERRO na abertura do arquivo";
			exit(1);      // usa biblioteca stdlib.h
		}
         
		fseek(l.arq, 0,0);
		fread(&comp, sizeof(comp),1,l.arq);

        if((i<=0) || (i>comp)) 
        {
                cerr<< "posicao invalida ou underflow ";
                exit(1);
        }
        else
        {
                fseek(l.arq,(i-1)*sizeof(tipo_do_elemento)+4,0);
				fread(&x,sizeof(tipo_do_elemento),1,l.arq);
				  
				if(i<comp)
                     for ( int k = i; k<=comp-1; k++)
					 {
					    fseek (l.arq,(k)*sizeof(tipo_do_elemento)+4,0);
						fread (&x,sizeof(tipo_do_elemento),1,l.arq);
						fseek (l.arq,(k-1)*sizeof(tipo_do_elemento)+4,0);
						fwrite(&x,sizeof(tipo_do_elemento),1,l.arq);
					  }
                comp--;
				fseek(l.arq,0,0);
				fwrite(&comp,sizeof(comp),1,l.arq);
				fclose(l.arq);
                return x;
        }
}

tipo_do_elemento consultar(Lista l, int i)
{
       
	tipo_do_elemento x;
	int comp;
	l.arq = fopen(nome_arquivo, "rb");

    // teste para verificar se ocorreu algum erro com a abertura

        if   (l.arq == NULL)
		{ 
			cout<< " ERRO na abertura do arquivo";
			exit(1);      // usa biblioteca stdlib.h
		}
        
        fseek(l.arq, 0,0);
		fread(&comp, sizeof(comp),1,l.arq);
		
	    if((i<=0) || (i>comp)) 
        {
                cerr<< "posicao invalida ou underflow ";
                exit(1);
        }
        else
		{
			fseek(l.arq,(i-1)*sizeof(tipo_do_elemento)+4,0);
			fread(&x, sizeof(tipo_do_elemento), 1,l.arq);
			fclose(l.arq);
			return x;
		}
}

void alterar(Lista& l, tipo_do_elemento x, int i)
{

	int comp;
	l.arq = fopen(nome_arquivo, "rb+");

    // teste para verificar se ocorreu algum erro com a abertura

        if   (l.arq == NULL)
		{ 
			cout<< " ERRO na abertura do arquivo";
			exit(1);      // usa biblioteca stdlib.h
		}
        
        fseek(l.arq, 0,0);
		fread(&comp, sizeof(comp),1,l.arq);
		
	    if((i<=0) || (i>comp)) 
        {
                cerr<< "posicao invalida ou underflow ";
                exit(1);
        }
        else
		{
			fseek (l.arq,(i-1)*sizeof(tipo_do_elemento)+4,0);
			fwrite(&x, sizeof(tipo_do_elemento), 1,l.arq);
			fclose(l.arq);
		}
		
}

int vazia(Lista l)
{
        if(compr(l) == 0) return 1;
        else return 0;
}

int compr (Lista& l)
{
    int comp;
	l.arq = fopen(nome_arquivo, "rb");

	if(l.arq == NULL)
	{
//		cout<<"\nErro ao abrir oarquivo";
//		exit(1);
		return 0;
	}
	else 
	{
		fseek(l.arq, 0,0);
		fread(&comp, sizeof(comp),1,l.arq);
		return comp;
	}
}
